﻿(: Retrieve the date of birth of the youngest and the oldest staff member for each group (clerks, doctors, and nurses). :)

(:

let $doc := fn:doc("doc.xml")
for $a in fn:distinct-values(
    for $s in $doc//staff/*
    return fn:node-name($s)
    )
let $g := $doc//staff/*[fn:node-name(.) = $a]
return element {$a} {
    element minDateOfBirth {
        fn:min($g//dateOfBirth)
    },
    element maxDateOfBirth {
        fn:max($g//dateOfBirth)
    }
}

Does not work. Saxon fails with the error message:
FORG0001: Failure converting {1973-07-14} to a number

However, the schema-aware version of Saxon should be able to process the query.
To work around this problem, date values can be explicitly casted.
:)

let $doc := fn:doc("doc.xml")
for $a in fn:distinct-values(
    for $s in $doc//staff/*
    return fn:node-name($s)
    )
let $g := $doc//staff/*[fn:node-name(.) = $a]
return element {$a} {
    element minDateOfBirth {
        fn:min(
            for $h in ($g/dateOfBirth) return $h cast as xs:date
        )
    },
    element maxDateOfBirth {
        fn:max(
            for $h in ($g/dateOfBirth) return $h cast as xs:date
        )
    }
}
